/*
 * smart_pointer.cpp     Smart pointer, Step 2.
 */
#include "smart_pointer.h"

namespace IDA_Smart_Pointer
{
   void swap(smart_pointer& x, smart_pointer& y)
   {
      x.swap(y);
   }

   bool operator==(const smart_pointer& lhs, const smart_pointer& rhs)
   { 
      return lhs.ptr_ == rhs.ptr_;
   }

   bool operator==(const smart_pointer& lhs, const int* rhs)
   {
      return lhs.ptr_ == rhs;
   }

   bool operator==(const int* lhs, const smart_pointer& rhs)
   {
      return lhs == rhs.ptr_;
   }

   bool operator!=(const smart_pointer& lhs, const smart_pointer& rhs)
   {
      return lhs.ptr_ != rhs.ptr_;
   }

   bool operator!=(const smart_pointer& lhs, const int* rhs)
   {
      return lhs.ptr_ != rhs;
   }

   bool operator!=(const int* lhs, const smart_pointer& rhs)
   {
      return lhs != rhs.ptr_;
   }

} // namespace IDA_Smart_Pointer
